searchData={"items":[{"type":"task","title":"mix compile.phoenix_swagger","doc":"See documentation for `Mix.Tasks.Phx.Swagger.Generate`","ref":"Mix.Tasks.Compile.PhoenixSwagger.html"},{"type":"function","title":"Mix.Tasks.Compile.PhoenixSwagger.filter_errors/1","doc":"","ref":"Mix.Tasks.Compile.PhoenixSwagger.html#filter_errors/1"},{"type":"function","title":"Mix.Tasks.Compile.PhoenixSwagger.run/1","doc":"Callback implementation for  Mix.Task.run/1 .","ref":"Mix.Tasks.Compile.PhoenixSwagger.html#run/1"},{"type":"task","title":"mix phx.swagger.generate","doc":"Generates swagger.json file based on phoenix router and controllers.\n\nUsage:\n\n    mix phx.swagger.generate\n\nSwagger file configuration must be defined in the project config, eg:\n\n    config :your_app, :phoenix_swagger,\n      swagger_files: %{\n        \"priv/static/swagger.json\" => [router: YourAppWeb.Router, endpoint: YourAppWeb.Endpoint]\n        # ... additional swagger files can be added here\n      }","ref":"Mix.Tasks.Phx.Swagger.Generate.html"},{"type":"function","title":"Mix.Tasks.Phx.Swagger.Generate.default_swagger_info/0","doc":"","ref":"Mix.Tasks.Phx.Swagger.Generate.html#default_swagger_info/0"},{"type":"function","title":"Mix.Tasks.Phx.Swagger.Generate.run/1","doc":"Callback implementation for  Mix.Task.run/1 .","ref":"Mix.Tasks.Phx.Swagger.Generate.html#run/1"},{"type":"module","title":"PhoenixSwagger","doc":"The PhoenixSwagger module provides macros for defining swagger operations and schemas.\n\nExample:\n\n    use PhoenixSwagger\n\n    swagger_path :create do\n      post \"/api/v1/{team}/users\"\n      summary \"Create a new user\"\n      consumes \"application/json\"\n      produces \"application/json\"\n      parameters do\n        user :body, Schema.ref(:User), \"user attributes\"\n        team :path, :string, \"Users team ID\"\n      end\n      response 200, \"OK\", Schema.ref(:User)\n    end\n\n    def swagger_definitions do\n      %{\n        User: swagger_schema do\n          title \"User\"\n          description \"A user of the application\"\n          properties do\n            name :string, \"Users name\", required: true\n            id :string, \"Unique identifier\", required: true\n            address :string, \"Home adress\"\n          end\n        end\n      }\n    end","ref":"PhoenixSwagger.html"},{"type":"function","title":"PhoenixSwagger.json_library/0","doc":"Use JSON library from phoenix configuration","ref":"PhoenixSwagger.html#json_library/0"},{"type":"function","title":"PhoenixSwagger.start/2","doc":"Callback implementation for  Application.start/2 .","ref":"PhoenixSwagger.html#start/2"},{"type":"macro","title":"PhoenixSwagger.swagger_path/2","doc":"Swagger operations (aka \"paths\") are defined inside a `swagger_path` block.\n\nWithin the do-end block, the DSL provided by the `PhoenixSwagger.Path` module can be used.\nThe DSL is any chain of functions with first argument being a `PhoenixSwagger.Path.PathObject` struct.\n\nThe verb and path can be set explicitly using the `get`, `put`, `post`, `patch`, `delete` functions, or\ninferred from the phoenix router automatically.\n\nSwagger `tags` will default to match the module name with trailing `Controller` removed.\nEg operations defined in module MyApp.UserController will have `tags: [\"User\"]`.\n\nSwagger `operationId` will default to the fully qualified action function name.\nEg `index` action in `MyApp.UserController` will have `operationId: \"MyApp.UserController.index\"`.","ref":"PhoenixSwagger.html#swagger_path/2"},{"type":"macro","title":"Example - PhoenixSwagger.swagger_path/2","doc":"defmodule ExampleController do\n      use ExampleApp.Web, :controller\n      use PhoenixSwagger\n\n      swagger_path :index do\n        get \"/users\"\n        summary \"Get users\"\n        description \"Get users, filtering by account ID\"\n        parameter :query, :id, :integer, \"account id\", required: true\n        response 200, \"Description\", :Users\n        tag \"users\"\n      end\n\n      def index(conn, _params) do\n        posts = Repo.all(Post)\n        render(conn, \"index.json\", posts: posts)\n      end\n    end","ref":"PhoenixSwagger.html#swagger_path/2-example"},{"type":"macro","title":"PhoenixSwagger.swagger_schema/1","doc":"Builds a swagger schema map using a DSL from the functions defined in `PhoenixSwagger.Schema`.","ref":"PhoenixSwagger.html#swagger_schema/1"},{"type":"macro","title":"Example - PhoenixSwagger.swagger_schema/1","doc":"iex> use PhoenixSwagger\n    ...> swagger_schema do\n    ...>   title \"Pet\"\n    ...>   description \"A pet in the pet store\"\n    ...>   properties do\n    ...>     id :integer, \"Unique identifier\", required: true, format: :int64\n    ...>     name :string, \"Pets name\", required: true\n    ...>     tags array(:string), \"Tag categories for this pet\"\n    ...>   end\n    ...>   additional_properties false\n    ...> end\n    %{\n      \"title\" => \"Pet\",\n      \"type\" => \"object\",\n      \"description\" => \"A pet in the pet store\",\n      \"properties\" => %{\n        \"id\" => %{\n          \"description\" => \"Unique identifier\",\n          \"format\" => \"int64\",\n          \"type\" => \"integer\"\n        },\n       \"name\" => %{\n          \"description\" => \"Pets name\",\n          \"type\" => \"string\"\n        },\n        \"tags\" => %{\n          \"description\" => \"Tag categories for this pet\",\n          \"items\" => %{\n            \"type\" => \"string\"\n          },\n          \"type\" => \"array\"\n        }\n      },\n      \"required\" => [\"name\", \"id\"],\n      \"additionalProperties\" => false\n    }\n\n    iex> use PhoenixSwagger\n    ...> swagger_schema do\n    ...>   title \"Phone\"\n    ...>   description \"An 8 digit phone number with optional 2 digit area code\"\n    ...>   type :string\n    ...>   max_length 11\n    ...>   pattern ~S\"^(([0-9]{2}))?[0-9]{4}-[0-9]{4}$\"\n    ...> end\n    %{\n      \"description\" => \"An 8 digit phone number with optional 2 digit area code\",\n      \"maxLength\" => 11,\n      \"pattern\" => \"^(\\([0-9]{2}\\))?[0-9]{4}-[0-9]{4}$\",\n      \"title\" => \"Phone\",\n      \"type\" => \"string\"\n    }","ref":"PhoenixSwagger.html#swagger_schema/1-example"},{"type":"module","title":"PhoenixSwagger.ConnValidator","doc":"","ref":"PhoenixSwagger.ConnValidator.html"},{"type":"function","title":"PhoenixSwagger.ConnValidator.validate/1","doc":"Validate a request.\n\nFeel free to use it in your own Plugs. Returns:\n* `{:ok, conn}` on success\n* `{:error, :no_matching_path}` if the request path could not be mapped to a schema\n* `{:error, message, path}` if the request was mapped but failed validation\n* `{:error, [{message, path}], path}` if more than one validation error has been detected","ref":"PhoenixSwagger.ConnValidator.html#validate/1"},{"type":"module","title":"PhoenixSwagger.JsonApi","doc":"This module defines a DSL for defining swagger definitions in a JSON-API conformant format.","ref":"PhoenixSwagger.JsonApi.html"},{"type":"module","title":"Examples - PhoenixSwagger.JsonApi","doc":"use PhoenixSwagger\n\n    def swagger_definitions do\n      %{\n        UserResource: JsonApi.resource do\n          description \"A user that may have one or more supporter pages.\"\n          attributes do\n            phone :string, \"Users phone number\"\n            full_name :string, \"Full name\"\n            user_updated_at :string, \"Last update timestamp UTC\", format: \"ISO-8601\"\n            user_created_at :string, \"First created timestamp UTC\"\n            email :string, \"Email\", required: true\n            birthday :string, \"Birthday in YYYY-MM-DD format\"\n            address Schema.ref(:Address), \"Users address\"\n          end\n          link :self, \"The link to this user resource\"\n          relationship :posts\n        end,\n        Users: JsonApi.page(:UserResource),\n        User: JsonApi.single(:UserResource)\n      }\n    end\n\n    swagger_path :index do\n      get \"/api/v1/users\"\n      paging size: \"page[size]\", number: \"page[number]\"\n      response 200, \"OK\", Schema.ref(:Users)\n    end","ref":"PhoenixSwagger.JsonApi.html#module-examples"},{"type":"function","title":"PhoenixSwagger.JsonApi.attribute/5","doc":"Defines an attribute in a JSON-API schema.\n\nName, type and description are accepted as positional arguments, but any other\nschema properties can be set through the trailing keyword arguments list.\n\nAs a convenience, required: true can be passed in the keyword args, causing the\n name of this attribute to be added to the \"required\" list of the attributes schema.","ref":"PhoenixSwagger.JsonApi.html#attribute/5"},{"type":"macro","title":"PhoenixSwagger.JsonApi.attributes/2","doc":"Defines a block of attributes for a JSON-API resource.\n\nWithin this block, each function call will be translated into a\ncall to the `PhoenixSwagger.JsonApi.attribute` function.","ref":"PhoenixSwagger.JsonApi.html#attributes/2"},{"type":"macro","title":"Examples - PhoenixSwagger.JsonApi.attributes/2","doc":"description(\"A User\")\n    attributes do\n      name :string, \"Full name of the user\", required: true\n      dateOfBirth :string, \"Date of Birth\", format: \"ISO-8601\", required: false\n    end\n\nTranslates to:\n\n    description(\"A User\")\n    |> attribute(:name, :string, \"Full name of the user\", required: true)\n    |> attribute(:dateOfBirth, :string, \"Date of Birth\", format: \"ISO-8601\", required: false)","ref":"PhoenixSwagger.JsonApi.html#attributes/2-examples"},{"type":"function","title":"PhoenixSwagger.JsonApi.link/3","doc":"Defines a link with name and description.","ref":"PhoenixSwagger.JsonApi.html#link/3"},{"type":"function","title":"PhoenixSwagger.JsonApi.page/1","doc":"Defines a schema for a top level json-api document with an array of resources as primary data.\n\nThe given `resource` should be the name of a JSON-API resource defined with the `resource/1` macro","ref":"PhoenixSwagger.JsonApi.html#page/1"},{"type":"function","title":"PhoenixSwagger.JsonApi.relationship/3","doc":"Defines a relationship.\n\nOptionally can pass `type: :has_many` or `type: :has_one` to determine\nwhether to structure the relationship as an object or array.\n\nDefaults to `:has_one`","ref":"PhoenixSwagger.JsonApi.html#relationship/3"},{"type":"macro","title":"PhoenixSwagger.JsonApi.resource/1","doc":"Defines a schema for a JSON-API resource, without the enclosing top-level document.","ref":"PhoenixSwagger.JsonApi.html#resource/1"},{"type":"function","title":"PhoenixSwagger.JsonApi.single/1","doc":"Defines a schema for a top level json-api document with a single primary data resource.\n\nThe given `resource` should be the name of a JSON-API resource defined with the `resource/1` macro","ref":"PhoenixSwagger.JsonApi.html#single/1"},{"type":"module","title":"PhoenixSwagger.Path","doc":"Defines the swagger path DSL for specifying Controller actions.\n\nThis module should not be imported directly, it will be automatically imported\nin the scope of a `swagger_path` macro body.","ref":"PhoenixSwagger.Path.html"},{"type":"module","title":"Examples - PhoenixSwagger.Path","doc":"use PhoenixSwagger\n\n    swagger_path :index do\n      get \"/users\"\n      produces \"application/json\"\n      paging\n      parameter :id, :query, :integer, \"user id\", required: true\n      tag \"Users\"\n      response 200 \"User resource\" :User\n      response 404 \"User not found\"\n    end","ref":"PhoenixSwagger.Path.html#module-examples"},{"type":"function","title":"PhoenixSwagger.Path.consumes/2","doc":"Adds a mime-type to the consumes list of the operation of a swagger `%PathObject{}`.","ref":"PhoenixSwagger.Path.html#consumes/2"},{"type":"function","title":"PhoenixSwagger.Path.delete/2","doc":"Initializes a PathObject with verb \"delete\" and given path","ref":"PhoenixSwagger.Path.html#delete/2"},{"type":"function","title":"PhoenixSwagger.Path.deprecated/2","doc":"Adds the deprecation section to the operation of a swagger `%PathObject{}`.","ref":"PhoenixSwagger.Path.html#deprecated/2"},{"type":"function","title":"PhoenixSwagger.Path.description/2","doc":"Adds the description section to the operation of a swagger `%PathObject{}`.","ref":"PhoenixSwagger.Path.html#description/2"},{"type":"function","title":"PhoenixSwagger.Path.expand_response_example/2","doc":"","ref":"PhoenixSwagger.Path.html#expand_response_example/2"},{"type":"function","title":"PhoenixSwagger.Path.get/2","doc":"Initializes a PathObject with verb \"get\" and given path","ref":"PhoenixSwagger.Path.html#get/2"},{"type":"function","title":"PhoenixSwagger.Path.head/2","doc":"Initializes a PathObject with verb \"head\" and given path","ref":"PhoenixSwagger.Path.html#head/2"},{"type":"function","title":"PhoenixSwagger.Path.nest/1","doc":"Converts the `%PathObject{}` struct into the nested JSON form expected by swagger.","ref":"PhoenixSwagger.Path.html#nest/1"},{"type":"function","title":"PhoenixSwagger.Path.operation_id/2","doc":"Adds the operationId section to the operation of a swagger `%PathObject{}`.","ref":"PhoenixSwagger.Path.html#operation_id/2"},{"type":"function","title":"PhoenixSwagger.Path.options/2","doc":"Initializes a PathObject with verb \"options\" and given path","ref":"PhoenixSwagger.Path.html#options/2"},{"type":"function","title":"PhoenixSwagger.Path.paging/2","doc":"Adds page size, number and offset parameters to the operation of a swagger `%PathObject{}`.\n\nThe names default to  \"page_size\" and \"page\" for ease of use with `scriviner_ecto`, but can be overridden.","ref":"PhoenixSwagger.Path.html#paging/2"},{"type":"function","title":"Examples - PhoenixSwagger.Path.paging/2","doc":"get \"/api/pets/\"\n    paging\n    response 200, \"OK\"\n\n    get \"/api/pets/dogs\"\n    paging size: \"page_size\", number: \"count\"\n    response 200, \"OK\"\n\n    get \"/api/pets/cats\"\n    paging size: \"limit\", offset: \"offset\"\n    response 200, \"OK\"","ref":"PhoenixSwagger.Path.html#paging/2-examples"},{"type":"function","title":"PhoenixSwagger.Path.parameter/6","doc":"Adds a parameter to the operation of a swagger `%PathObject{}`.","ref":"PhoenixSwagger.Path.html#parameter/6"},{"type":"macro","title":"PhoenixSwagger.Path.parameters/2","doc":"Defines multiple parameters for an operation with a custom DSL syntax.","ref":"PhoenixSwagger.Path.html#parameters/2"},{"type":"macro","title":"Examples - PhoenixSwagger.Path.parameters/2","doc":"swagger_path :create do\n      post \"/api/v1/{team}/users\"\n      summary \"Create a new user\"\n      parameters do\n        user :body, Schema.ref(:User), \"user attributes\"\n        team :path, :string, \"Users team ID\"\n      end\n      response 200, \"OK\", :User\n    end","ref":"PhoenixSwagger.Path.html#parameters/2-examples"},{"type":"function","title":"PhoenixSwagger.Path.patch/2","doc":"Initializes a PathObject with verb \"patch\" and given path","ref":"PhoenixSwagger.Path.html#patch/2"},{"type":"function","title":"PhoenixSwagger.Path.post/2","doc":"Initializes a PathObject with verb \"post\" and given path","ref":"PhoenixSwagger.Path.html#post/2"},{"type":"function","title":"PhoenixSwagger.Path.produces/2","doc":"Adds a mime-type to the produces list of the operation of a swagger `%PathObject{}`.","ref":"PhoenixSwagger.Path.html#produces/2"},{"type":"function","title":"PhoenixSwagger.Path.put/2","doc":"Initializes a PathObject with verb \"put\" and given path","ref":"PhoenixSwagger.Path.html#put/2"},{"type":"function","title":"PhoenixSwagger.Path.response/3","doc":"Adds a response to the operation of a swagger `%PathObject{}`, without a schema.","ref":"PhoenixSwagger.Path.html#response/3"},{"type":"function","title":"PhoenixSwagger.Path.response/5","doc":"Adds a response to the operation of a swagger `%PathObject{}`, with a schema.\n\nOptional keyword args can be provided for `headers` and `examples`.\n\nIf the mime-type is known from the `produces` list, then a single can be given as a shorthand.","ref":"PhoenixSwagger.Path.html#response/5"},{"type":"function","title":"Examples - PhoenixSwagger.Path.response/5","doc":"get \"/users/{id}\"\n    produces \"application/json\"\n    parameter :id, :path, :integer, \"user id\", required: true\n    response 200, \"Success\", :User, examples: %{\"application/json\": %{id: 1, name: \"Joe\"}}\n\n    get \"/users/{id}\"\n    produces \"application/json\"\n    parameter :id, :path, :integer, \"user id\", required: true\n    response 200, \"Success\", :User, example: %{id: 1, name: \"Joe\"}","ref":"PhoenixSwagger.Path.html#response/5-examples"},{"type":"function","title":"PhoenixSwagger.Path.security/2","doc":"Adds the security section to the operation of a swagger `%PathObject{}`.","ref":"PhoenixSwagger.Path.html#security/2"},{"type":"function","title":"PhoenixSwagger.Path.summary/2","doc":"Adds the summary section to the operation of a swagger `%PathObject{}`.","ref":"PhoenixSwagger.Path.html#summary/2"},{"type":"function","title":"PhoenixSwagger.Path.tag/2","doc":"Adds a tag to the operation of a swagger `%PathObject{}`.","ref":"PhoenixSwagger.Path.html#tag/2"},{"type":"module","title":"PhoenixSwagger.Path.OperationObject","doc":"A swagger operation object ties together parameters, responses, etc.\n\nSee http://swagger.io/specification/#operationObject","ref":"PhoenixSwagger.Path.OperationObject.html"},{"type":"module","title":"PhoenixSwagger.Path.Parameter","doc":"A swagger parameter definition, similar to a `Schema`, but swagger defines\nparameter name (and some other options) to be part of the parameter object itself.\n\nSee http://swagger.io/specification/#parameterObject","ref":"PhoenixSwagger.Path.Parameter.html"},{"type":"module","title":"PhoenixSwagger.Path.PathObject","doc":"The DSL builds paths out of individual operations, so this is a flattened version\nof a swagger Path.\n\nThe `nest` function will convert this to a nested map before final\nconversion to a JSON map.\n\nSee http://swagger.io/specification/#pathsObject","ref":"PhoenixSwagger.Path.PathObject.html"},{"type":"module","title":"PhoenixSwagger.Path.ResponseObject","doc":"A swagger response definition.\n\nThe response status (200, 404, etc.) is the key in the containing map.\n\nSee http://swagger.io/specification/#responseObject","ref":"PhoenixSwagger.Path.ResponseObject.html"},{"type":"module","title":"PhoenixSwagger.Plug.SwaggerUI","doc":"Swagger UI in a plug.","ref":"PhoenixSwagger.Plug.SwaggerUI.html"},{"type":"module","title":"Examples - PhoenixSwagger.Plug.SwaggerUI","doc":"Generate a swagger file and place it in your applications `priv/static` dir:\n\n    mix phoenix.swagger.generate priv/static/myapp.json\n\nAdd a swagger scope to your router, and forward all requests to SwaggerUI\n\n    scope \"myapp/api/swagger\" do\n      forward \"/\", PhoenixSwagger.Plug.SwaggerUI, otp_app: :myapp, swagger_file: \"myapp.json\"\n    end\n\nRun the server with `mix phoenix.server` and browse to `localhost:8080/myapp/api/swagger/`,\nswagger-ui should be shown with your swagger spec loaded.","ref":"PhoenixSwagger.Plug.SwaggerUI.html#module-examples"},{"type":"function","title":"PhoenixSwagger.Plug.SwaggerUI.call/2","doc":"Plug.call callback","ref":"PhoenixSwagger.Plug.SwaggerUI.html#call/2"},{"type":"function","title":"PhoenixSwagger.Plug.SwaggerUI.init/1","doc":"Plug.init callback\n\nOptions:\n\n - `otp_app` (required) The name of the app has is hosting the swagger file\n - `swagger_file` (required) The name of the file, eg \"swagger.json\"\n - `config_object` (optional) These values are injected into the config object passed to SwaggerUI.\n - `config_url` (optional) Populates the `configUrl` Swagger UI parameter. A URL to fetch an external configuration document from.","ref":"PhoenixSwagger.Plug.SwaggerUI.html#init/1"},{"type":"module","title":"PhoenixSwagger.Plug.Validate","doc":"A plug to automatically validate all requests in a given scope.\n\nPlease make sure to:\n\n  * load Swagger specs at appliction start with\n    `PhoenixSwagger.Validator.parse_swagger_schema/1`\n  * set `conn.private.phoenix_swagger.valid` to `true` to skip validation","ref":"PhoenixSwagger.Plug.Validate.html"},{"type":"function","title":"PhoenixSwagger.Plug.Validate.call/2","doc":"","ref":"PhoenixSwagger.Plug.Validate.html#call/2"},{"type":"function","title":"PhoenixSwagger.Plug.Validate.init/1","doc":"Plug.init callback\n\nOptions:\n\n  * `:validation_failed_status` the response status to set when parameter validation fails, defaults to 400.","ref":"PhoenixSwagger.Plug.Validate.html#init/1"},{"type":"module","title":"PhoenixSwagger.Schema","doc":"Struct and helpers for swagger schema.\n\nFields should reflect the swagger SchemaObject specification.\n\nSee http://swagger.io/specification/#schemaObject","ref":"PhoenixSwagger.Schema.html"},{"type":"function","title":"PhoenixSwagger.Schema.additional_properties/2","doc":"Boolean indicating that additional properties are allowed, or\na schema to be used for validating any additional properties not listed in `properties`.\n\nDefault behaviour is to allow additional properties.","ref":"PhoenixSwagger.Schema.html#additional_properties/2"},{"type":"function","title":"Examples - PhoenixSwagger.Schema.additional_properties/2","doc":"iex> alias PhoenixSwagger.Schema\n    ...> %Schema{type: :object}\n    ...> |> Schema.property(:name, :string, \"Full name\", maxLength: 255)\n    ...> |> Schema.additional_properties(false)\n    %PhoenixSwagger.Schema{\n      type: :object,\n      properties: %{\n        name: %PhoenixSwagger.Schema{\n          type: :string,\n          description: \"Full name\",\n          maxLength: 255\n        }\n      },\n      additionalProperties: false\n    }\n\n    iex> alias PhoenixSwagger.Schema\n    ...> %Schema{type: :object}\n    ...> |> Schema.property(:name, :string, \"Full name\", maxLength: 255)\n    ...> |> Schema.additional_properties(%Schema{type: :number})\n    %PhoenixSwagger.Schema{\n      type: :object,\n      properties: %{\n        name: %PhoenixSwagger.Schema{\n          type: :string,\n          description: \"Full name\",\n          maxLength: 255\n        }\n      },\n      additionalProperties: %PhoenixSwagger.Schema{\n        type: :number\n      }\n    }","ref":"PhoenixSwagger.Schema.html#additional_properties/2-examples"},{"type":"function","title":"PhoenixSwagger.Schema.all_of/2","doc":"Used to combine multiple schemas, requiring a value to conform to all schemas.\n\nCan be used in conjunction with `discriminator` to define polymorphic inheritance relationships.\n\nSee http://swagger.io/specification/#composition-and-inheritance--polymorphism--83","ref":"PhoenixSwagger.Schema.html#all_of/2"},{"type":"function","title":"Examples - PhoenixSwagger.Schema.all_of/2","doc":"iex> alias PhoenixSwagger.Schema\n    ...> %Schema{}\n    ...> |> Schema.all_of([Schema.ref(\"#definitions/Contact\"), Schema.ref(\"#definitions/CreditHistory\")])\n    %PhoenixSwagger.Schema{\n      allOf: [\n        %PhoenixSwagger.Schema{\"$ref\": \"#definitions/Contact\"},\n        %PhoenixSwagger.Schema{\"$ref\": \"#definitions/CreditHistory\"},\n      ]\n    }","ref":"PhoenixSwagger.Schema.html#all_of/2-examples"},{"type":"function","title":"PhoenixSwagger.Schema.array/1","doc":"Construct an array schema, where the array items schema is a ref to the given name.","ref":"PhoenixSwagger.Schema.html#array/1"},{"type":"function","title":"Examples - PhoenixSwagger.Schema.array/1","doc":"iex> PhoenixSwagger.Schema.array(:User)\n    %PhoenixSwagger.Schema{\n      items: %PhoenixSwagger.Schema{\"$ref\": \"#/definitions/User\"},\n      type: :array\n    }\n\n    iex> PhoenixSwagger.Schema.array(:string)\n    %PhoenixSwagger.Schema{\n      items: %PhoenixSwagger.Schema{type: :string},\n      type: :array\n    }","ref":"PhoenixSwagger.Schema.html#array/1-examples"},{"type":"function","title":"PhoenixSwagger.Schema.default/2","doc":"Sets the default value for the schema.\n\nThe value provided should validate against the schema sucessfully.","ref":"PhoenixSwagger.Schema.html#default/2"},{"type":"function","title":"Examples - PhoenixSwagger.Schema.default/2","doc":"iex> alias PhoenixSwagger.Schema\n    ...> %Schema{type: :string, format: :datetime}\n    ...> |> Schema.default(\"2017-01-01T00:00:00Z\")\n    %PhoenixSwagger.Schema{\n      type: :string,\n      format: :datetime,\n      default: \"2017-01-01T00:00:00Z\"\n    }","ref":"PhoenixSwagger.Schema.html#default/2-examples"},{"type":"function","title":"PhoenixSwagger.Schema.description/2","doc":"Sets the description for the schema.","ref":"PhoenixSwagger.Schema.html#description/2"},{"type":"function","title":"Examples - PhoenixSwagger.Schema.description/2","doc":"iex> alias PhoenixSwagger.Schema\n    ...> %Schema{} |> Schema.description(\"A user\")\n    %PhoenixSwagger.Schema{description: \"A user\"}","ref":"PhoenixSwagger.Schema.html#description/2-examples"},{"type":"function","title":"PhoenixSwagger.Schema.discriminator/2","doc":"Specifies the name of a property that identifies the polymorphic schema for a JSON object.\n\nThe value of this property should be the name of this schema, or another schema that inherits\nfrom this schema using `all_of`.\n\nSee http://swagger.io/specification/#composition-and-inheritance--polymorphism--83","ref":"PhoenixSwagger.Schema.html#discriminator/2"},{"type":"function","title":"Examples - PhoenixSwagger.Schema.discriminator/2","doc":"iex> alias PhoenixSwagger.Schema\n    ...> %Schema{}\n    ...> |> Schema.type(:object)\n    ...> |> Schema.title(\"Pet\")\n    ...> |> Schema.property(:pet_type, :string, \"polymorphic pet schema type\", example: \"Dog\")\n    ...> |> Schema.discriminator(:pet_type)\n    %Schema{\n      type: :object,\n      title: \"Pet\",\n      properties: %{\n        pet_type: %Schema{\n          type: :string,\n          description: \"polymorphic pet schema type\",\n          example: \"Dog\"\n        }\n      },\n      discriminator: :pet_type,\n      required: [:pet_type]\n    }","ref":"PhoenixSwagger.Schema.html#discriminator/2-examples"},{"type":"function","title":"PhoenixSwagger.Schema.enum/2","doc":"Restricts the schema to a fixed set of values.","ref":"PhoenixSwagger.Schema.html#enum/2"},{"type":"function","title":"Examples - PhoenixSwagger.Schema.enum/2","doc":"iex> alias PhoenixSwagger.Schema\n    ...> %Schema{type: :string}\n    ...> |> Schema.enum([\"red\", \"yellow\", \"green\"])\n    %PhoenixSwagger.Schema{type: :string, enum: [\"red\", \"yellow\", \"green\"]}","ref":"PhoenixSwagger.Schema.html#enum/2-examples"},{"type":"function","title":"PhoenixSwagger.Schema.example/2","doc":"Adds an example of the schema.","ref":"PhoenixSwagger.Schema.html#example/2"},{"type":"function","title":"Examples - PhoenixSwagger.Schema.example/2","doc":"iex> alias PhoenixSwagger.Schema\n    ...> %Schema{type: :object, properties: %{phone_number: %Schema{type: :string}}}\n    ...> |> Schema.example(%{phone_number: \"555-123-456\"})\n    %PhoenixSwagger.Schema{\n      type: :object,\n      properties: %{\n        phone_number: %PhoenixSwagger.Schema{\n          type: :string\n        }\n      },\n      example: %{phone_number: \"555-123-456\"}\n    }","ref":"PhoenixSwagger.Schema.html#example/2-examples"},{"type":"function","title":"PhoenixSwagger.Schema.exclusive_maximum/2","doc":"Boolean indicating that value for `maximum` is excluded from the valid range.\n\nWhen true: `x < maximum`, when false: `x <= maximum`","ref":"PhoenixSwagger.Schema.html#exclusive_maximum/2"},{"type":"function","title":"Examples - PhoenixSwagger.Schema.exclusive_maximum/2","doc":"iex> alias PhoenixSwagger.Schema\n    ...> %Schema{type: :number}\n    ...> |> Schema.maximum(128)\n    ...> |> Schema.exclusive_maximum(true)\n    %PhoenixSwagger.Schema{\n      type: :number,\n      maximum: 128,\n      exclusiveMaximum: true\n    }","ref":"PhoenixSwagger.Schema.html#exclusive_maximum/2-examples"},{"type":"function","title":"PhoenixSwagger.Schema.exclusive_minimum/2","doc":"Boolean indicating that value for `minimum` is excluded from the valid range.\n\nWhen true: `x > minimum`, when false: `x => minimum`.","ref":"PhoenixSwagger.Schema.html#exclusive_minimum/2"},{"type":"function","title":"Examples - PhoenixSwagger.Schema.exclusive_minimum/2","doc":"iex> alias PhoenixSwagger.Schema\n    ...> %Schema{type: :number}\n    ...> |> Schema.minimum(16)\n    ...> |> Schema.exclusive_minimum(true)\n    %PhoenixSwagger.Schema{\n      type: :number,\n      minimum: 16,\n      exclusiveMinimum: true\n    }","ref":"PhoenixSwagger.Schema.html#exclusive_minimum/2-examples"},{"type":"function","title":"PhoenixSwagger.Schema.format/2","doc":"Sets the format of a Schema with `type: :string`.","ref":"PhoenixSwagger.Schema.html#format/2"},{"type":"function","title":"Examples - PhoenixSwagger.Schema.format/2","doc":"iex> alias PhoenixSwagger.Schema\n    ...> %Schema{type: :string} |> Schema.format(:datetime)\n    %PhoenixSwagger.Schema{type: :string, format: :datetime}","ref":"PhoenixSwagger.Schema.html#format/2-examples"},{"type":"function","title":"PhoenixSwagger.Schema.items/2","doc":"Sets the schema/s for the items of an array.\n\nUse a single schema for arrays when each item should have the same schema.\nUse a list of schemas when the array represents a tuple, each element will be validated against\nthe corresponding schema in the `items` list.","ref":"PhoenixSwagger.Schema.html#items/2"},{"type":"function","title":"Examples - PhoenixSwagger.Schema.items/2","doc":"iex> alias PhoenixSwagger.Schema\n    ...> %Schema{type: :array}\n    ...> |> Schema.items(%Schema{type: :string})\n    %PhoenixSwagger.Schema{type: :array, items: %PhoenixSwagger.Schema{type: :string}}\n\n    iex> alias PhoenixSwagger.Schema\n    ...> %Schema{type: :array}\n    ...> |> Schema.items([%Schema{type: :string}, %Schema{type: :number}])\n    %PhoenixSwagger.Schema{\n      type: :array,\n      items: [%PhoenixSwagger.Schema{type: :string}, %PhoenixSwagger.Schema{type: :number}]\n    }","ref":"PhoenixSwagger.Schema.html#items/2-examples"},{"type":"function","title":"PhoenixSwagger.Schema.max_items/2","doc":"Restricts the maximimum number of items in an `array` schema.","ref":"PhoenixSwagger.Schema.html#max_items/2"},{"type":"function","title":"Examples - PhoenixSwagger.Schema.max_items/2","doc":"iex> alias PhoenixSwagger.Schema\n    ...> %Schema{type: :array}\n    ...> |> Schema.max_items(25)\n    %PhoenixSwagger.Schema{type: :array, maxItems: 25}","ref":"PhoenixSwagger.Schema.html#max_items/2-examples"},{"type":"function","title":"PhoenixSwagger.Schema.max_length/2","doc":"Constrains the maximum length of a string to the given value.","ref":"PhoenixSwagger.Schema.html#max_length/2"},{"type":"function","title":"Examples - PhoenixSwagger.Schema.max_length/2","doc":"iex> alias PhoenixSwagger.Schema\n    ...> %Schema{type: :string}\n    ...> |> Schema.max_length(255)\n    %PhoenixSwagger.Schema{type: :string, maxLength: 255}","ref":"PhoenixSwagger.Schema.html#max_length/2-examples"},{"type":"function","title":"PhoenixSwagger.Schema.max_properties/2","doc":"Limits the maximum number of properties an `object` schema may contain.","ref":"PhoenixSwagger.Schema.html#max_properties/2"},{"type":"function","title":"Examples - PhoenixSwagger.Schema.max_properties/2","doc":"iex> alias PhoenixSwagger.Schema\n    ...> %Schema{type: :object}\n    ...> |> Schema.max_properties(10)\n    %PhoenixSwagger.Schema{type: :object, maxProperties: 10}","ref":"PhoenixSwagger.Schema.html#max_properties/2-examples"},{"type":"function","title":"PhoenixSwagger.Schema.maximum/2","doc":"Specifies a maximum numeric value for :integer or :number types.","ref":"PhoenixSwagger.Schema.html#maximum/2"},{"type":"function","title":"Examples - PhoenixSwagger.Schema.maximum/2","doc":"iex> alias PhoenixSwagger.Schema\n    ...> %Schema{type: :integer}\n    ...> |> Schema.maximum(100)\n    %PhoenixSwagger.Schema{type: :integer, maximum: 100}","ref":"PhoenixSwagger.Schema.html#maximum/2-examples"},{"type":"function","title":"PhoenixSwagger.Schema.min_items/2","doc":"Restricts the minimum number of items in an `array` schema.","ref":"PhoenixSwagger.Schema.html#min_items/2"},{"type":"function","title":"Examples - PhoenixSwagger.Schema.min_items/2","doc":"iex> alias PhoenixSwagger.Schema\n    ...> %Schema{type: :array}\n    ...> |> Schema.min_items(1)\n    %PhoenixSwagger.Schema{type: :array, minItems: 1}","ref":"PhoenixSwagger.Schema.html#min_items/2-examples"},{"type":"function","title":"PhoenixSwagger.Schema.min_length/2","doc":"Constrains the minimum length of a string to the given value.","ref":"PhoenixSwagger.Schema.html#min_length/2"},{"type":"function","title":"Examples - PhoenixSwagger.Schema.min_length/2","doc":"iex> alias PhoenixSwagger.Schema\n    ...> %Schema{type: :string}\n    ...> |> Schema.min_length(32)\n    %PhoenixSwagger.Schema{type: :string, minLength: 32}","ref":"PhoenixSwagger.Schema.html#min_length/2-examples"},{"type":"function","title":"PhoenixSwagger.Schema.min_properties/2","doc":"Limits the minimum number of properties an `object` schema may contain.","ref":"PhoenixSwagger.Schema.html#min_properties/2"},{"type":"function","title":"Examples - PhoenixSwagger.Schema.min_properties/2","doc":"iex> alias PhoenixSwagger.Schema\n    ...> %Schema{type: :object}\n    ...> |> Schema.min_properties(1)\n    %PhoenixSwagger.Schema{type: :object, minProperties: 1}","ref":"PhoenixSwagger.Schema.html#min_properties/2-examples"},{"type":"function","title":"PhoenixSwagger.Schema.minimum/2","doc":"Specifies a minimum numeric value for `:integer` or `:number` types.","ref":"PhoenixSwagger.Schema.html#minimum/2"},{"type":"function","title":"Examples - PhoenixSwagger.Schema.minimum/2","doc":"iex> alias PhoenixSwagger.Schema\n    ...> %Schema{type: :integer}\n    ...> |> Schema.minimum(10)\n    %PhoenixSwagger.Schema{type: :integer, minimum: 10}","ref":"PhoenixSwagger.Schema.html#minimum/2-examples"},{"type":"function","title":"PhoenixSwagger.Schema.multiple_of/2","doc":"Limits a values of numeric type (:integer or :number) to multiples of the given amount.","ref":"PhoenixSwagger.Schema.html#multiple_of/2"},{"type":"function","title":"Examples - PhoenixSwagger.Schema.multiple_of/2","doc":"iex> alias PhoenixSwagger.Schema\n    ...> %Schema{type: :number}\n    ...> |> Schema.multiple_of(7)\n    %PhoenixSwagger.Schema{type: :number, multipleOf: 7}","ref":"PhoenixSwagger.Schema.html#multiple_of/2-examples"},{"type":"macro","title":"PhoenixSwagger.Schema.new/1","doc":"Construct a new %Schema{} struct using the schema DSL.\n\nThis macro is similar to PhoenixSwagger.swagger_schema, except that it\nproduces a Schema struct instead of a plain map with string keys.","ref":"PhoenixSwagger.Schema.html#new/1"},{"type":"macro","title":"Examples - PhoenixSwagger.Schema.new/1","doc":"iex> require PhoenixSwagger.Schema, as: Schema\n    ...> Schema.new do\n    ...>   type :object\n    ...>   properties do\n    ...>     name :string, \"user name\", required: true\n    ...>     date_of_birth :string, \"date of birth\", format: :datetime\n    ...>   end\n    ...> end\n    %Schema{\n      type: :object,\n      properties: %{\n        name: %Schema {\n          type: :string,\n          description: \"user name\"\n        },\n        date_of_birth: %Schema {\n          type: :string,\n          format: :datetime,\n          description: \"date of birth\"\n        }\n      },\n      required: [:name]\n    }","ref":"PhoenixSwagger.Schema.html#new/1-examples"},{"type":"function","title":"PhoenixSwagger.Schema.nullable/2","doc":"Sets the `x-nullable` vendor extension property for the schema.","ref":"PhoenixSwagger.Schema.html#nullable/2"},{"type":"function","title":"Examples - PhoenixSwagger.Schema.nullable/2","doc":"iex> alias PhoenixSwagger.Schema\n    ...> %Schema{type: :string} |> Schema.nullable(true)\n    %Schema{\n      type: :string,\n      \"x-nullable\": true\n    }","ref":"PhoenixSwagger.Schema.html#nullable/2-examples"},{"type":"function","title":"PhoenixSwagger.Schema.pattern/2","doc":"Restricts a string schema to match a regular expression, given as a string.","ref":"PhoenixSwagger.Schema.html#pattern/2"},{"type":"function","title":"Examples - PhoenixSwagger.Schema.pattern/2","doc":"iex> alias PhoenixSwagger.Schema\n    ...> %Schema{type: :string}\n    ...> |> Schema.pattern(~S\"^(([0-9]{2}))?[0-9]{4}-[0-9]{4}$\")\n    %PhoenixSwagger.Schema{type: :string, pattern: ~S\"^(([0-9]{2}))?[0-9]{4}-[0-9]{4}$\"}","ref":"PhoenixSwagger.Schema.html#pattern/2-examples"},{"type":"macro","title":"PhoenixSwagger.Schema.properties/2","doc":"Defines multiple properties for a schema with a custom DSL syntax.","ref":"PhoenixSwagger.Schema.html#properties/2"},{"type":"macro","title":"Examples - PhoenixSwagger.Schema.properties/2","doc":"iex> alias PhoenixSwagger.Schema\n    ...> %Schema{type: :object}\n    ...> |> Schema.properties do\n    ...>      name :string, \"Full Name\", required: true\n    ...>      dateOfBirth :string, \"Date of birth\", format: :datetime\n    ...>    end\n    %PhoenixSwagger.Schema{\n      type: :object,\n      properties: %{\n        name: %PhoenixSwagger.Schema{\n          type: :string,\n          description: \"Full Name\",\n        },\n        dateOfBirth: %PhoenixSwagger.Schema{\n          type: :string,\n          description: \"Date of birth\",\n          format: :datetime\n        }\n      },\n      required: [:name]\n    }","ref":"PhoenixSwagger.Schema.html#properties/2-examples"},{"type":"function","title":"PhoenixSwagger.Schema.property/5","doc":"Sets a property of the Schema.","ref":"PhoenixSwagger.Schema.html#property/5"},{"type":"function","title":"Examples - PhoenixSwagger.Schema.property/5","doc":"iex> alias PhoenixSwagger.Schema\n    ...> %Schema{type: :object}\n    ...> |> Schema.property(:name, :string, \"Full name\", required: true, maxLength: 256)\n    ...> |> Schema.property(:address, [:string, \"null\"], \"Street Address\")\n    ...> |> Schema.property(:friends, Schema.array(:User), \"Friends list\", required: true)\n    %PhoenixSwagger.Schema{\n      type: :object,\n      properties: %{\n        friends: %PhoenixSwagger.Schema{\n          type: :array,\n          description: \"Friends list\",\n          items: %PhoenixSwagger.Schema{\"$ref\": \"#/definitions/User\"}\n        },\n        address: %PhoenixSwagger.Schema{\n          type: [:string, \"null\"],\n          description: \"Street Address\"\n        },\n        name: %PhoenixSwagger.Schema{\n          type: :string,\n          description: \"Full name\",\n          maxLength: 256\n        }\n      },\n      required: [:friends, :name]\n    }","ref":"PhoenixSwagger.Schema.html#property/5-examples"},{"type":"function","title":"PhoenixSwagger.Schema.ref/1","doc":"Construct a schema reference, using name of definition in this swagger document,\nor a complete path.","ref":"PhoenixSwagger.Schema.html#ref/1"},{"type":"function","title":"Examples - PhoenixSwagger.Schema.ref/1","doc":"iex> PhoenixSwagger.Schema.ref(:User)\n    %PhoenixSwagger.Schema{\"$ref\": \"#/definitions/User\"}\n\n    iex> PhoenixSwagger.Schema.ref(\"../common/Error.json\")\n    %PhoenixSwagger.Schema{\"$ref\": \"../common/Error.json\"}","ref":"PhoenixSwagger.Schema.html#ref/1-examples"},{"type":"function","title":"PhoenixSwagger.Schema.required/2","doc":"Makes one or more properties required in an object schema.","ref":"PhoenixSwagger.Schema.html#required/2"},{"type":"function","title":"Examples - PhoenixSwagger.Schema.required/2","doc":"iex> alias PhoenixSwagger.Schema\n    ...> %Schema{type: :object, properties: %{phone_number: %Schema{type: :string}}}\n    ...> |> Schema.required(:phone_number)\n    %PhoenixSwagger.Schema{\n      type: :object,\n      properties: %{\n        phone_number: %PhoenixSwagger.Schema{\n          type: :string\n        }\n      },\n      required: [:phone_number]\n    }\n\n    iex> alias PhoenixSwagger.Schema\n    ...> %Schema{type: :object, properties: %{phone_number: %Schema{type: :string}, address: %Schema{type: :string}}}\n    ...> |> Schema.required([:phone_number, :address])\n    %PhoenixSwagger.Schema{\n      type: :object,\n      properties: %{\n        phone_number: %PhoenixSwagger.Schema{\n          type: :string\n        },\n        address: %PhoenixSwagger.Schema{\n          type: :string\n        }\n      },\n      required: [:phone_number, :address]\n    }","ref":"PhoenixSwagger.Schema.html#required/2-examples"},{"type":"function","title":"PhoenixSwagger.Schema.title/2","doc":"Sets the title of the schema.","ref":"PhoenixSwagger.Schema.html#title/2"},{"type":"function","title":"Examples - PhoenixSwagger.Schema.title/2","doc":"iex> alias PhoenixSwagger.Schema\n    ...> %Schema{} |> Schema.title(\"User\")\n    %PhoenixSwagger.Schema{title: \"User\"}","ref":"PhoenixSwagger.Schema.html#title/2-examples"},{"type":"function","title":"PhoenixSwagger.Schema.type/2","doc":"Sets the type of for the schema.\n\nValid values are `:string`, `:integer`, `:number`, `:object`, `:array`, `:boolean`, `:null`,\nor a list of those basic types.","ref":"PhoenixSwagger.Schema.html#type/2"},{"type":"function","title":"Examples - PhoenixSwagger.Schema.type/2","doc":"iex> alias PhoenixSwagger.Schema\n    ...> %Schema{}\n    ...> |> Schema.type(:string)\n    %PhoenixSwagger.Schema{type: :string}\n\n    iex> alias PhoenixSwagger.Schema\n    ...> %Schema{}\n    ...> |> Schema.type([:string, :integer])\n    %PhoenixSwagger.Schema{type: [:string, :integer]}","ref":"PhoenixSwagger.Schema.html#type/2-examples"},{"type":"function","title":"PhoenixSwagger.Schema.unique_items/2","doc":"Boolean that when true, requires each item of an `array` schema to be unique.","ref":"PhoenixSwagger.Schema.html#unique_items/2"},{"type":"function","title":"Examples - PhoenixSwagger.Schema.unique_items/2","doc":"iex> alias PhoenixSwagger.Schema\n    ...> %Schema{type: :array}\n    ...> |> Schema.unique_items(true)\n    %PhoenixSwagger.Schema{type: :array, uniqueItems: true}","ref":"PhoenixSwagger.Schema.html#unique_items/2-examples"},{"type":"module","title":"PhoenixSwagger.SchemaTest","doc":"Testing helper module that makes it convenient to assert that phoenix controller responses conform to a swagger spec.","ref":"PhoenixSwagger.SchemaTest.html"},{"type":"module","title":"Example - PhoenixSwagger.SchemaTest","doc":"use YourApp.ConnCase\n    use PhoenixSwagger.SchemaTest \"priv/static/swagger.json\"\n\n    test \"Get a user by ID\", %{conn: conn, swagger_schema: schema} do\n      user = Repo.insert! struct(User, @valid_attrs)\n      response =\n        conn\n        |> get(user_path(conn, :show, user))\n        |> validate_resp_schema(schema, \"UserResponse\")\n        |> json_response(200)\n\n      assert response[\"data\"][\"id\"] == user.id\n    end\n\nErrors will be output with the json-path of the location in the response body for the error:\n\n    Response JSON does not conform to swagger schema from #/definitions/UserResponse.\n    At #/data/email: Expected \"foobaz\" to be an email address.\n    {\n      \"data\": {\n        \"name\": \"Yu Ser\",\n        \"id\": 141,\n        \"email\": \"foobaz\"\n      }\n    }","ref":"PhoenixSwagger.SchemaTest.html#module-example"},{"type":"macro","title":"PhoenixSwagger.SchemaTest.__using__/1","doc":"Given a swagger file path, defines an ExUnit `setup_all` block that will\nadd the resolved swagger schema to the ExUnit context.","ref":"PhoenixSwagger.SchemaTest.html#__using__/1"},{"type":"function","title":"PhoenixSwagger.SchemaTest.validate_resp_schema/3","doc":"Validates a response body against a swagger schema.","ref":"PhoenixSwagger.SchemaTest.html#validate_resp_schema/3"},{"type":"function","title":"Example - PhoenixSwagger.SchemaTest.validate_resp_schema/3","doc":"use MyApp.ConnCase\n    use PhoenixSwagger.SchemaTest \"priv/static/swagger.json\"\n\n    test \"get user by ID\", %{conn: conn, swagger_schema: schema} do\n      response =\n        conn\n        |> get(user_path(conn, :show, 123))\n        |> validate_resp_schema(schema, \"User\")\n        |> json_response(200)\n\n      assert response[\"data\"][\"id\"] == 123\n    end","ref":"PhoenixSwagger.SchemaTest.html#validate_resp_schema/3-example"},{"type":"module","title":"PhoenixSwagger.Validator","doc":"The PhoenixSwagger.Validator module provides converter of\nswagger schema to ex_json_schema structure for further validation.\n\nThere are two main functions:\n\n  * parse_swagger_schema/1\n  * validate/2\n\nBefore `validate/2` will be called, a swagger schema should be parsed\nfor futher validation with the `parse_swagger_schema/1`. This function\ntakes path to a swagger schema and returns it in ex_json_schema format.\n\nDuring execution of the `parse_swagger_schema/1` function, it creates\nthe `validator_table` ets table and stores associative key/value there.\nWhere `key` is an API path of a resource and `value` is input parameters\nof a resource.\n\nTo validate of a parsed swagger schema, the `validate/1` should be used.\n\nFor more information, see more in ./phoenix_swagger/tests/ directory.","ref":"PhoenixSwagger.Validator.html"},{"type":"function","title":"PhoenixSwagger.Validator.parse_swagger_schema/1","doc":"The `parse_swagger_schema/1` takes path or list of paths to a swagger schema(s),\nparses it/them into ex_json_schema format and store to the `validator_table` ets\ntable.","ref":"PhoenixSwagger.Validator.html#parse_swagger_schema/1"},{"type":"function","title":"Examples - PhoenixSwagger.Validator.parse_swagger_schema/1","doc":"iex(1)> parse_swagger_schema(\"my_json_spec.json\")\n    [{\"/person\",  %{'__struct__' => 'Elixir.ExJsonSchema.Schema.Root',\n                    location => root,\n                    refs => %{},\n                    schema => %{\n                      \"properties\" => %{\n                        \"name\" => %{\"type\" => \"string\"},\n                        \"age\" => %{\"type\" => \"integer\"}\n                      }\n                    }\n                  }\n    }]","ref":"PhoenixSwagger.Validator.html#parse_swagger_schema/1-examples"},{"type":"function","title":"PhoenixSwagger.Validator.validate/2","doc":"The `validate/2` takes a resource path and input parameters\nof this resource.\n\nReturns `:ok` in a case when parameters are valid for the\ngiven resource or:\n\n  * `{:error, :resource_not_exists}` in a case when path is not\n    exists in the validator table\n\n  * `{:error, error_message, path}` in a case when at least\n    one  parameter is not valid for the given resource","ref":"PhoenixSwagger.Validator.html#validate/2"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"v0.8.4 - 2025-05-29 - Changelog","doc":"* swagger-ui-dist updated to 5.2.0.\n  * Fix validation of boolean properties. Thanks to @charl3sj\n  * Allow nullable `$ref`. Thanks to @ericsullivan\n  * Nullable fields validated correctly. Thanks to @ericsullivan\n  * Add support SwaggerUI config object injection. Thanks to @heroinbob\n  * Add support to have property names with `-` symbol. Thanks to @fahadnaeemkhan\n  * Documentation improvements. Thanks to @kianmeng and @leticiapenha\n  * Use Elixir formatter. Thanks to @naps62\n  * Remove ex_json_schema from startup. Thanks to @lukaszsamson\n  * Update dependencies and phoenix_swagger itself for Elixir >= 1.16.0","ref":"changelog.html#v0-8-4-2025-05-29"},{"type":"extras","title":"v0.8.3 - 2021-01-15 - Changelog","doc":"* Fix broken param parsing caused from Plug 1.11.0\n  * Allow swagger ui validator url to be customized\n  * `validatorUrl` replaced with `configUrl`\n  * Warning messages fixed for Elixir 1.11\n  * dialyxir, plug, ex_json_schema and other dependencies are updated to the latests versions","ref":"changelog.html#v0-8-3-2021-01-15"},{"type":"extras","title":"v0.8.2 - 2019-12-12 - Changelog","doc":"* Add support for Phoenix ~> 1.4.9\n  * Ability to configure json library e.g. config `:phoenix_swagger, json_library: Jason`\n  * Improvements in SwagerUI Plug\n  * Update dependencies\n  * Bug fixes","ref":"changelog.html#v0-8-2-2019-12-12"},{"type":"extras","title":"v0.8.1 - 2018-07-06 - Changelog","doc":"* Fix for crash on non-GET requests\n  * Fix compilation error running `mix phx.swagger.generate` before `mix compile`\n  * Validate number type in query parameter\n  * Add `id` and `type` properties to the `included`-items schema\n  * Add `Schema.nullable` function to set the `x-nullable` property\n  * Add `nullable:` option to `JsonSchema.relationship` function\n  * Handle `x-nullable` schemas in `SchemaTest`\n  * Add `deprecated` flag for operations","ref":"changelog.html#v0-8-1-2018-07-06"},{"type":"extras","title":"v0.8.0 - 2018-03-13 - Changelog","doc":"* Passing module names and output path as mix task parameters is no longer supported.\n  * Inferring default module names from mix project is no longer supported.\n  * Swagger file outputs, router module and optional endpoint module must now be specified in application config:\n\n    ```elixir\n    config :my_app, :phoenix_swagger,\n      swagger_files: %{\n        \"priv/static/swagger.json\" => [router: MyAppWeb.Router, endpoint: MyAppWeb.Endpoint],\n        # additional swagger files here\n      }\n    ```\n\n  * `phoenix_swagger` can now be run as a mix compiler task, ensuring that the generated swagger is kept in sync with code, and enabling live reloading.\n\n    ```elixir\n    compilers: [:phoenix, :gettext, :phoenix_swagger] ++ Mix.compilers\n    ```\n\n  * The HTTP verb and path can now be inferred from the phoenix router:\n\n    ```elixir\n    swagger_path :show do\n      get \"/api/users/{id}\n      description \"Gets a user by ID\"\n      response 200, \"OK\", Schema.ref(User)\n    end\n    ```\n    Can now be written without the `get`:\n\n    ```elixir\n    swagger_path :show do\n      description \"Gets a user by ID\"\n      response 200, \"OK\", Schema.ref(User)\n    end\n    ```\n\n    Note that if your controller contains a `delete/2` function (such as when using the `resources` convention), then calling `delete/2` from `PhoenixSwagger.Path` will now cause a compilation error. To avoid this problem, include the full module (shown below), or simply remove the line and allow the verb and path to be inferred from the route:\n\n    ```elixir\n    swagger_path(:delete) do\n      PhoenixSwagger.Path.delete \"/api/users/{id}\"\n      summary \"Delete User\"\n    end\n    ```","ref":"changelog.html#v0-8-0-2018-03-13"},{"type":"extras","title":"v0.7.1 - 2017-11-09 - Changelog","doc":"* Use the :load_from_system_env Endpoint config flag to detect dynamic host and port configuration","ref":"changelog.html#v0-7-1-2017-11-09"},{"type":"extras","title":"v0.7.0 - 2017-11-09 - Changelog","doc":"* Minor fix that supports the Phoenix 1.3 namespacing, where it is {Project}Web instead of {Project}.Web.\n  * Add support for has_many relationships for JSON-API resource schemas\n  * Upgrade to swagger-ui 3.1.7\n  * Tests for nested and non-nested required parameters for `PhoenixSwagger.Plug.Validate`.\n  *  Decode parameter names using `Plug.Conn.Query.decode` and walk `conn.params` to find the nested param as `conn.params` is already nested while `parameter[\"name\"]` is not when received by `PhoenixSwagger.Plug.Validate.validate_query_params/2`.","ref":"changelog.html#v0-7-0-2017-11-09"},{"type":"extras","title":"v0.6.4 - 2017-07-15 - Changelog","doc":"* Adds support to enable security by endpoint\n  * `PhoenixSwagger.Plug.Validate` sets response content type on error to `application/json`\n  * `PhoenixSwagger.Plug.Validate` accepts `:validation_failed_status` option, defaults to 400\n  * Example application includes usage of validator","ref":"changelog.html#v0-6-4-2017-07-15"},{"type":"extras","title":"v0.6.3 - 2017-06-17 - Changelog","doc":"* Adds support for custom Endpoint module names by passing `--endpoint`\n  * Added patch request support","ref":"changelog.html#v0-6-3-2017-06-17"},{"type":"extras","title":"v0.6.2 - 2017-05-09 - Changelog","doc":"* fix path assignation of a swagger specification file in UI plug\n  * add `disable_validator` option to disable/enable validation of a\nswagger schema.","ref":"changelog.html#v0-6-2-2017-05-09"},{"type":"extras","title":"v0.6.1 - 2017-05-09 - Changelog","doc":"* Provide default host and port when generating swagger host config\n  * Suppress host config when dynamic hostname or port are used","ref":"changelog.html#v0-6-1-2017-05-09"},{"type":"extras","title":"v0.6.0 - 2017-05-03 - Changelog","doc":"* Use phoenix 1.3 conventions for mix tasks and module names\n  * Add `PhoenixSwagger.SchemaTest` module for response validation\n  * Swagger UI plug redirects / to /index.html automatically avoiding errors when fetching assets.\n  * Swagger UI configured to list all operations by default","ref":"changelog.html#v0-6-0-2017-05-03"},{"type":"extras","title":"v0.5.1 - 2017-03-29 - Changelog","doc":"* Allow property schemas to be declared inline using `Schema.new` macro\n  * Allow schemas to include an example\n  * Add support for `discriminator` in polymorphic schemas\n  * Do not set a host if a url has not been provided\n  * Ability to validate boolean values","ref":"changelog.html#v0-5-1-2017-03-29"},{"type":"extras","title":"v0.5.0 - 2017-03-13 - Changelog","doc":"* Include swagger-ui plug `PhoenixSwagger.Plug.SwaggerUI`\n  * Allow for a list of types on `PhoenixSwagger.Schema.type`\n  * Fix not running all doctests\n  * Fix `ArgumentError` in `Phoenix.Swagger.Generate` when routing to plug with keyword opts [#58](https://github.com/xerions/phoenix_swagger/issues/58)","ref":"changelog.html#v0-5-0-2017-03-13"},{"type":"extras","title":"v0.4.2 - 2017-02-22 - Changelog","doc":"* Fix FunctionClauseError in `response` when no `produces` mime type defined on an operation.","ref":"changelog.html#v0-4-2-2017-02-22"},{"type":"extras","title":"v0.4.1 - 2017-02-21 - Changelog","doc":"* Fix compilation errors when using `PhoenixSwagger.JsonApi` macros","ref":"changelog.html#v0-4-1-2017-02-21"},{"type":"extras","title":"v0.4.0 - 2017-02-20 - Changelog","doc":"* Add `PhoenixSwagger.Schema` module that provides a structure which represents\nswagger schema.\n  * Add `swagger_schema` macro to build a swagger schema.\n  * New JSON-API helpers.\n  * Provide documentation with ex_doc.\n  * And other changes from @everydayhero fork.","ref":"changelog.html#v0-4-0-2017-02-20"},{"type":"extras","title":"License","doc":"Mozilla Public License, version 2.0\n\n1. Definitions\n\n1.1. \"Contributor\"\n\n     means each individual or legal entity that creates, contributes to the\n     creation of, or owns Covered Software.\n\n1.2. \"Contributor Version\"\n\n     means the combination of the Contributions of others (if any) used by a\n     Contributor and that particular Contributor's Contribution.\n\n1.3. \"Contribution\"\n\n     means Covered Software of a particular Contributor.\n\n1.4. \"Covered Software\"\n\n     means Source Code Form to which the initial Contributor has attached the\n     notice in Exhibit A, the Executable Form of such Source Code Form, and\n     Modifications of such Source Code Form, in each case including portions\n     thereof.\n\n1.5. \"Incompatible With Secondary Licenses\"\n     means\n\n     a. that the initial Contributor has attached the notice described in\n        Exhibit B to the Covered Software; or\n\n     b. that the Covered Software was made available under the terms of\n        version 1.1 or earlier of the License, but not also under the terms of\n        a Secondary License.\n\n1.6. \"Executable Form\"\n\n     means any form of the work other than Source Code Form.\n\n1.7. \"Larger Work\"\n\n     means a work that combines Covered Software with other material, in a\n     separate file or files, that is not Covered Software.\n\n1.8. \"License\"\n\n     means this document.\n\n1.9. \"Licensable\"\n\n     means having the right to grant, to the maximum extent possible, whether\n     at the time of the initial grant or subsequently, any and all of the\n     rights conveyed by this License.\n\n1.10. \"Modifications\"\n\n     means any of the following:\n\n     a. any file in Source Code Form that results from an addition to,\n        deletion from, or modification of the contents of Covered Software; or\n\n     b. any new file in Source Code Form that contains any Covered Software.\n\n1.11. \"Patent Claims\" of a Contributor\n\n      means any patent claim(s), including without limitation, method,\n      process, and apparatus claims, in any patent Licensable by such\n      Contributor that would be infringed, but for the grant of the License,\n      by the making, using, selling, offering for sale, having made, import,\n      or transfer of either its Contributions or its Contributor Version.\n\n1.12. \"Secondary License\"\n\n      means either the GNU General Public License, Version 2.0, the GNU Lesser\n      General Public License, Version 2.1, the GNU Affero General Public\n      License, Version 3.0, or any later versions of those licenses.\n\n1.13. \"Source Code Form\"\n\n      means the form of the work preferred for making modifications.\n\n1.14. \"You\" (or \"Your\")\n\n      means an individual or a legal entity exercising rights under this\n      License. For legal entities, \"You\" includes any entity that controls, is\n      controlled by, or is under common control with You. For purposes of this\n      definition, \"control\" means (a) the power, direct or indirect, to cause\n      the direction or management of such entity, whether by contract or\n      otherwise, or (b) ownership of more than fifty percent (50%) of the\n      outstanding shares or beneficial ownership of such entity.\n\n\n2. License Grants and Conditions\n\n2.1. Grants\n\n     Each Contributor hereby grants You a world-wide, royalty-free,\n     non-exclusive license:\n\n     a. under intellectual property rights (other than patent or trademark)\n        Licensable by such Contributor to use, reproduce, make available,\n        modify, display, perform, distribute, and otherwise exploit its\n        Contributions, either on an unmodified basis, with Modifications, or\n        as part of a Larger Work; and\n\n     b. under Patent Claims of such Contributor to make, use, sell, offer for\n        sale, have made, import, and otherwise transfer either its\n        Contributions or its Contributor Version.\n\n2.2. Effective Date\n\n     The licenses granted in Section 2.1 with respect to any Contribution\n     become effective for each Contribution on the date the Contributor first\n     distributes such Contribution.\n\n2.3. Limitations on Grant Scope\n\n     The licenses granted in this Section 2 are the only rights granted under\n     this License. No additional rights or licenses will be implied from the\n     distribution or licensing of Covered Software under this License.\n     Notwithstanding Section 2.1(b) above, no patent license is granted by a\n     Contributor:\n\n     a. for any code that a Contributor has removed from Covered Software; or\n\n     b. for infringements caused by: (i) Your and any other third party's\n        modifications of Covered Software, or (ii) the combination of its\n        Contributions with other software (except as part of its Contributor\n        Version); or\n\n     c. under Patent Claims infringed by Covered Software in the absence of\n        its Contributions.\n\n     This License does not grant any rights in the trademarks, service marks,\n     or logos of any Contributor (except as may be necessary to comply with\n     the notice requirements in Section 3.4).\n\n2.4. Subsequent Licenses\n\n     No Contributor makes additional grants as a result of Your choice to\n     distribute the Covered Software under a subsequent version of this\n     License (see Section 10.2) or under the terms of a Secondary License (if\n     permitted under the terms of Section 3.3).\n\n2.5. Representation\n\n     Each Contributor represents that the Contributor believes its\n     Contributions are its original creation(s) or it has sufficient rights to\n     grant the rights to its Contributions conveyed by this License.\n\n2.6. Fair Use\n\n     This License is not intended to limit any rights You have under\n     applicable copyright doctrines of fair use, fair dealing, or other\n     equivalents.\n\n2.7. Conditions\n\n     Sections 3.1, 3.2, 3.3, and 3.4 are conditions of the licenses granted in\n     Section 2.1.\n\n\n3. Responsibilities\n\n3.1. Distribution of Source Form\n\n     All distribution of Covered Software in Source Code Form, including any\n     Modifications that You create or to which You contribute, must be under\n     the terms of this License. You must inform recipients that the Source\n     Code Form of the Covered Software is governed by the terms of this\n     License, and how they can obtain a copy of this License. You may not\n     attempt to alter or restrict the recipients' rights in the Source Code\n     Form.\n\n3.2. Distribution of Executable Form\n\n     If You distribute Covered Software in Executable Form then:\n\n     a. such Covered Software must also be made available in Source Code Form,\n        as described in Section 3.1, and You must inform recipients of the\n        Executable Form how they can obtain a copy of such Source Code Form by\n        reasonable means in a timely manner, at a charge no more than the cost\n        of distribution to the recipient; and\n\n     b. You may distribute such Executable Form under the terms of this\n        License, or sublicense it under different terms, provided that the\n        license for the Executable Form does not attempt to limit or alter the\n        recipients' rights in the Source Code Form under this License.\n\n3.3. Distribution of a Larger Work\n\n     You may create and distribute a Larger Work under terms of Your choice,\n     provided that You also comply with the requirements of this License for\n     the Covered Software. If the Larger Work is a combination of Covered\n     Software with a work governed by one or more Secondary Licenses, and the\n     Covered Software is not Incompatible With Secondary Licenses, this\n     License permits You to additionally distribute such Covered Software\n     under the terms of such Secondary License(s), so that the recipient of\n     the Larger Work may, at their option, further distribute the Covered\n     Software under the terms of either this License or such Secondary\n     License(s).\n\n3.4. Notices\n\n     You may not remove or alter the substance of any license notices\n     (including copyright notices, patent notices, disclaimers of warranty, or\n     limitations of liability) contained within the Source Code Form of the\n     Covered Software, except that You may alter any license notices to the\n     extent required to remedy known factual inaccuracies.\n\n3.5. Application of Additional Terms\n\n     You may choose to offer, and to charge a fee for, warranty, support,\n     indemnity or liability obligations to one or more recipients of Covered\n     Software. However, You may do so only on Your own behalf, and not on\n     behalf of any Contributor. You must make it absolutely clear that any\n     such warranty, support, indemnity, or liability obligation is offered by\n     You alone, and You hereby agree to indemnify every Contributor for any\n     liability incurred by such Contributor as a result of warranty, support,\n     indemnity or liability terms You offer. You may include additional\n     disclaimers of warranty and limitations of liability specific to any\n     jurisdiction.\n\n4. Inability to Comply Due to Statute or Regulation\n\n   If it is impossible for You to comply with any of the terms of this License\n   with respect to some or all of the Covered Software due to statute,\n   judicial order, or regulation then You must: (a) comply with the terms of\n   this License to the maximum extent possible; and (b) describe the\n   limitations and the code they affect. Such description must be placed in a\n   text file included with all distributions of the Covered Software under\n   this License. Except to the extent prohibited by statute or regulation,\n   such description must be sufficiently detailed for a recipient of ordinary\n   skill to be able to understand it.\n\n5. Termination\n\n5.1. The rights granted under this License will terminate automatically if You\n     fail to comply with any of its terms. However, if You become compliant,\n     then the rights granted under this License from a particular Contributor\n     are reinstated (a) provisionally, unless and until such Contributor\n     explicitly and finally terminates Your grants, and (b) on an ongoing\n     basis, if such Contributor fails to notify You of the non-compliance by\n     some reasonable means prior to 60 days after You have come back into\n     compliance. Moreover, Your grants from a particular Contributor are\n     reinstated on an ongoing basis if such Contributor notifies You of the\n     non-compliance by some reasonable means, this is the first time You have\n     received notice of non-compliance with this License from such\n     Contributor, and You become compliant prior to 30 days after Your receipt\n     of the notice.\n\n5.2. If You initiate litigation against any entity by asserting a patent\n     infringement claim (excluding declaratory judgment actions,\n     counter-claims, and cross-claims) alleging that a Contributor Version\n     directly or indirectly infringes any patent, then the rights granted to\n     You by any and all Contributors for the Covered Software under Section\n     2.1 of this License shall terminate.\n\n5.3. In the event of termination under Sections 5.1 or 5.2 above, all end user\n     license agreements (excluding distributors and resellers) which have been\n     validly granted by You or Your distributors under this License prior to\n     termination shall survive termination.\n\n6. Disclaimer of Warranty\n\n   Covered Software is provided under this License on an \"as is\" basis,\n   without warranty of any kind, either expressed, implied, or statutory,\n   including, without limitation, warranties that the Covered Software is free\n   of defects, merchantable, fit for a particular purpose or non-infringing.\n   The entire risk as to the quality and performance of the Covered Software\n   is with You. Should any Covered Software prove defective in any respect,\n   You (not any Contributor) assume the cost of any necessary servicing,\n   repair, or correction. This disclaimer of warranty constitutes an essential\n   part of this License. No use of  any Covered Software is authorized under\n   this License except under this disclaimer.\n\n7. Limitation of Liability\n\n   Under no circumstances and under no legal theory, whether tort (including\n   negligence), contract, or otherwise, shall any Contributor, or anyone who\n   distributes Covered Software as permitted above, be liable to You for any\n   direct, indirect, special, incidental, or consequential damages of any\n   character including, without limitation, damages for lost profits, loss of\n   goodwill, work stoppage, computer failure or malfunction, or any and all\n   other commercial damages or losses, even if such party shall have been\n   informed of the possibility of such damages. This limitation of liability\n   shall not apply to liability for death or personal injury resulting from\n   such party's negligence to the extent applicable law prohibits such\n   limitation. Some jurisdictions do not allow the exclusion or limitation of\n   incidental or consequential damages, so this exclusion and limitation may\n   not apply to You.\n\n8. Litigation\n\n   Any litigation relating to this License may be brought only in the courts\n   of a jurisdiction where the defendant maintains its principal place of\n   business and such litigation shall be governed by laws of that\n   jurisdiction, without reference to its conflict-of-law provisions. Nothing\n   in this Section shall prevent a party's ability to bring cross-claims or\n   counter-claims.\n\n9. Miscellaneous\n\n   This License represents the complete agreement concerning the subject\n   matter hereof. If any provision of this License is held to be\n   unenforceable, such provision shall be reformed only to the extent\n   necessary to make it enforceable. Any law or regulation which provides that\n   the language of a contract shall be construed against the drafter shall not\n   be used to construe this License against a Contributor.\n\n\n10. Versions of the License\n\n10.1. New Versions\n\n      Mozilla Foundation is the license steward. Except as provided in Section\n      10.3, no one other than the license steward has the right to modify or\n      publish new versions of this License. Each version will be given a\n      distinguishing version number.\n\n10.2. Effect of New Versions\n\n      You may distribute the Covered Software under the terms of the version\n      of the License under which You originally received the Covered Software,\n      or under the terms of any subsequent version published by the license\n      steward.\n\n10.3. Modified Versions\n\n      If you create software not governed by this License, and you want to\n      create a new license for such software, you may create and use a\n      modified version of this License if you rename the license and remove\n      any references to the name of the license steward (except to note that\n      such modified license differs from this License).\n\n10.4. Distributing Source Code Form that is Incompatible With Secondary\n      Licenses If You choose to distribute Source Code Form that is\n      Incompatible With Secondary Licenses under the terms of this version of\n      the License, the notice described in Exhibit B of this License must be\n      attached.\n\nExhibit A - Source Code Form License Notice\n\n      This Source Code Form is subject to the\n      terms of the Mozilla Public License, v.\n      2.0. If a copy of the MPL was not\n      distributed with this file, You can\n      obtain one at\n      http://mozilla.org/MPL/2.0/.\n\nIf it is not possible or desirable to put the notice in a particular file,\nthen You may include the notice in a location (such as a LICENSE file in a\nrelevant directory) where a recipient would be likely to look for such a\nnotice.\n\nYou may add additional accurate notices of copyright ownership.\n\nExhibit B - \"Incompatible With Secondary Licenses\" Notice\n\n      This Source Code Form is \"Incompatible\n      With Secondary Licenses\", as defined by\n      the Mozilla Public License, v. 2.0.","ref":"license.html"},{"type":"extras","title":"Overview","doc":"# PhoenixSwagger\n\n[![Build Status](https://travis-ci.org/xerions/phoenix_swagger.svg?branch=master)](https://travis-ci.org/xerions/phoenix_swagger)\n[![Module Version](https://img.shields.io/hexpm/v/phoenix_swagger.svg)](https://hex.pm/packages/phoenix_swagger)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/phoenix_swagger/)\n[![Total Download](https://img.shields.io/hexpm/dt/phoenix_swagger.svg)](https://hex.pm/packages/phoenix_swagger)\n[![License](https://img.shields.io/hexpm/l/phoenix_swagger.svg)](https://github.com/xerions/phoenix_swagger/blob/master/LICENSE)\n[![Last Updated](https://img.shields.io/github/last-commit/xerions/phoenix_swagger.svg)](https://github.com/xerions/phoenix_swagger/commits/master)\n\n`PhoenixSwagger` is the library that provides [swagger](http://swagger.io/) integration\nto the [phoenix](http://www.phoenixframework.org/) web framework.\n\n - Generate a swagger api specification from phoenix router and controllers\n - Serve [swagger-ui](https://swagger.io/swagger-ui/)\n - Validate requests against parameter schemas\n - Validate responses against schemas in tests\n\n# Installation\n\nFollow the [getting started guide](https://hexdocs.pm/phoenix_swagger/getting-started.html) to install and configure `PhoenixSwagger`.\n\n# Guides\n\nSee the [full documentation on hexdocs.pm](https://hexdocs.pm/phoenix_swagger) or browse the [guides](https://github.com/xerions/phoenix_swagger/tree/master/guides) directory.\n\n# Contributing\n\nIssues and pull requests welcome. You'll also find help on the [#phoenix_swagger](https://elixir-lang.slack.com/messages/phoenix_swagger) channel on the [elixir-lang slack](https://elixir-lang.slack.com).\n\n# License\n\n[Mozilla Public License 2.0](./LICENSE)","ref":"readme.html"},{"type":"extras","title":"Getting Started","doc":"# Getting Started\n\n`PhoenixSwagger` provides a mix compiler and mix task `phx.swagger.generate` for the swagger-ui `json`\nfile generation that contains swagger specification that describes API of the `phoenix`\napplication.\n\nYou just need to add the swagger DSL to your controllers and then run this one mix task\nto generate the JSON files.","ref":"getting-started.html"},{"type":"extras","title":"Installation - Getting Started","doc":"To use `PhoenixSwagger` with a phoenix application just add it to your list of\ndependencies in the `mix.exs` file:\n\n```elixir\ndef deps do\n  [\n    {:phoenix_swagger, \"~> 0.8\"},\n    {:ex_json_schema, \"~> 0.5\"} # optional\n  ]\nend\n```\n\n`ex_json_schema` is an optional dependency of `phoenix_swagger` required only for schema validation plug and test helper.\n\nAppend `:phoenix_swagger` to the list of compilers to automatically update the swagger files each time the app is compiled:\n\n```elixir\ndef project do\n[\n  ...\n  compilers: [:phoenix, :gettext] ++ Mix.compilers ++ [:phoenix_swagger],\n  ...\nend\n```","ref":"getting-started.html#installation"},{"type":"extras","title":"Configuration - Getting Started","doc":"Add a config entry to your phoenix application specifying the output filename, router and endpoint modules used to generate the swagger file:\n\n```elixir\nconfig :my_app, :phoenix_swagger,\n  swagger_files: %{\n    \"priv/static/swagger.json\" => [\n      router: MyAppWeb.Router,     # phoenix routes will be converted to swagger paths\n      endpoint: MyAppWeb.Endpoint  # (optional) endpoint config used to set host, port and https schemes.\n    ]\n  }\n```\n\nIf multiple swagger files need to be generated, add additional entries to the project config:\n\n```elixir\nconfig :my_app, :phoenix_swagger,\n  swagger_files: %{\n    \"booking-api.json\" => [router: MyApp.BookingRouter],\n    \"reports-api.json\" => [router: MyApp.ReportsRouter],\n    \"admin-api.json\" => [router: MyApp.AdminRouter]\n  }\n```\n\nAlso you can configure JSON library to use:\n\n```\nconfig :phoenix_swagger, json_library: Jason\n```","ref":"getting-started.html#configuration"},{"type":"extras","title":"Router - Getting Started","doc":"The outline of the swagger document should be returned from a `swagger_info/0` function\ndefined in your phoenix `Router.ex` module.\n\n```elixir\ndefmodule MyApp.Router do\n  use MyApp.Web, :router\n\n  pipeline :api do\n    plug :accepts, [\"json\"]\n  end\n\n  scope \"/api\", MyApp do\n    pipe_through :api\n    resources \"/users\", UserController\n  end\n\n  def swagger_info do\n    %{\n      info: %{\n        version: \"1.0\",\n        title: \"My App\"\n      }\n    }\n  end\nend\n```\n\nThe `version` and `title` are mandatory fields. By default the `version` will be `0.0.1`\nand the `title` will be ` ` if you do not provide `swagger_info/0`\nfunction.\n\nSee the [Swagger Object specification](https://github.com/OAI/OpenAPI-Specification/blob/master/versions/2.0.md#swagger-object) for details\nof other information that can be included. `basePath` is optional but may need to be specified if your API routes do not reside at the root location `/`. You can also set the description of `tags` here, for example:\n\n```elixir\n%{\n  basePath: \"/api\",\n  info: %{..},\n  tags: [%{name: \"Users\", description: \"Operations about Users\"}]\n}\n```","ref":"getting-started.html#router"},{"type":"extras","title":"Endpoint - Getting Started","doc":"The swagger `host` value is built from your phoenix `Endpoint` `url` config.\n\n```elixir\n# config.exs\nconfig :my_app, MyApp.Web.Endpoint,\n  url: [host: \"localhost\"], # \"host\": \"localhost:4000\" in generated swagger\n```\n\nIf the `host` is configured to be set dynamically (either by `{:systems, \"VAR\"}` tuples or the `:load_from_system_env` flag), the swagger host will be omitted. SwaggerUI will default to sending requests to the same host that is serving the swagger file.\n\n```elixir\n# prod.exs\nconfig :my_app, MyApp.Web.Endpoint,\n  load_from_system_env: true, # Expects url host and port to be configured in Endpoint.init callback\n  url: [host: \"example.com\", port: 80],\n```","ref":"getting-started.html#endpoint"},{"type":"extras","title":"Generate Swagger File - Getting Started","doc":"Once you have a minimal configuration and `swagger_info` function in the router, run the `phx.swagger.generate`\nmix task for the `swagger` JSON file generation into directory with `phoenix` application:\n\n```\nmix phx.swagger.generate\n```","ref":"getting-started.html#generate-swagger-file"},{"type":"extras","title":"Schemas","doc":"# Schemas\n\nSchema definitions are placed in a `swagger_definitions/0` function within each controller module.\nThis function should return a map in the format of a swagger [definitionsObject](http://swagger.io/specification/#definitionsObject).\n\nThe `swagger_schema/2` macro can be used to build a schema definition using the functions provided by the `PhoenixSwagger.Schema` module.\n\nExample:\n\n```elixir\ndef swagger_definitions do\n  %{\n    User: swagger_schema do\n      title \"User\"\n      description \"A user of the application\"\n      properties do\n        name :string, \"Users name\", required: true\n        id :string, \"Unique identifier\", required: true\n        address :string, \"Home address\"\n        preferences (Schema.new do\n          properties do\n            subscribe_to_mailing_list :boolean, \"mailing list subscription\", default: true\n            send_special_offers :boolean, \"special offers list subscription\", default: true\n          end\n        end)\n      end\n      example %{\n        name: \"Joe\",\n        id: \"123\",\n        address: \"742 Evergreen Terrace\"\n      }\n    end,\n    Users: swagger_schema do\n      title \"Users\"\n      description \"A collection of Users\"\n      type :array\n      items Schema.ref(:User)\n    end\n  }\nend\n```","ref":"schemas.html"},{"type":"extras","title":"Operations","doc":"# Operations\n\n`PhoenixSwagger` provides `swagger_path/2` macro that generates swagger specification\nfor the certain phoenix controller action.\n\nExample:\n\n```elixir\nuse PhoenixSwagger\n\nswagger_path :index do\n  get \"/posts\"\n  description \"List blog posts\"\n  response 200, \"Success\"\nend\n\ndef index(conn, _params) do\n  posts = Repo.all(Post)\n  render(conn, \"index.json\", posts: posts)\nend\n```\n\nThe `swagger_path` macro takes two parameters:\n\n* Name of controller action;\n* `do` block that contains the `swagger` specification for the controller action.\n\nWithin the do-end block, the DSL provided by the `PhoenixSwagger.Path` module can be used.\n\nExample:\n\n```elixir\nswagger_path :index do\n  get \"/api/v1/{org_id}/users\"\n  summary \"Query for users\"\n  description \"Query for users. This operation supports with paging and filtering\"\n  produces \"application/json\"\n  tag \"Users\"\n  operation_id \"list_users\"\n  paging\n  parameters do\n    org_id :path, :string, \"Organization ID\", required: true\n    zipcode :query, :string, \"Address Zip Code\", required: true, example: \"90210\"\n    include :query, :array, \"Related resources to include in response\",\n              items: [type: :string, enum: [:organisation, :favourites, :purchases]],\n              collectionFormat: :csv\n  end\n  response 200, \"OK\", Schema.ref(:Users)\n  response 400, \"Client Error\"\nend\n```\n\nThe `swagger_path` macro layer is just some syntactic sugar over regular elixir functions. Therefore it can easily be extended, for instance, if we want to reuse some common parameters.\n\nFor more details on this take a look at [Reusing Swagger Parameters](https://hexdocs.pm/phoenix_swagger/reusing-swagger-parameters.html).\n\nNote the imported `PhoenixSwagger.Path.delete/2` function may clash with your own `delete/2` function in the controller.\nOften you can just remove this function call, since the route will be inferred automatically. If you need to customize the route for swagger, then use a qualified function call to disambiguate:\n\n```elixir\n  swagger_path :delete do\n    PhoenixSwagger.Path.delete \"/api/users/{id}\"\n    summary \"Delete User\"\n    description \"Delete a user by ID\"\n    parameter :id, :path, :integer, \"User ID\", required: true, example: 3\n    response 203, \"No Content - Deleted Successfully\"\n  end\n```","ref":"operations.html"},{"type":"extras","title":"Reusing swagger parameters","doc":"# Reusing swagger parameters\n\nWhen building an API it can be common to have headers or parameters that are common to multiple actions.","ref":"reusing-swagger-parameters.html"},{"type":"extras","title":"Scenario - Reusing swagger parameters","doc":"For example, let's say we've got two endpoints:\n- `GET /projects`\n- `GET /books`\n\nBoth of these endpoints can be sorted using by `sort_by` and `sort_direction` parameters and both require an Authorization header.\n\nHere's what the swagger spec in our `ProjectsController` would look like:\n\n```elixir\ndefmodule ProjectsController do\n  use PhoenixSwagger\n\n  swagger_path :index do\n    get \"/projects\"\n    produces \"application/json\"\n    parameter(\"Authorization\", :header, :string, \"OAuth2 access token\", required: true)\n    parameters do      \n      sort_by :query, :string, \"The property to sort by\"\n      sort_direction :query, :string, \"The sort direction\", enum: [:asc, :desc], default: :asc\n      company_id :string, :query, \"The company id\"\n    end\n  end\nend\n```\n\nOur BooksController swagger would look very similar, also defining the `Authorization` header and the `sort_by` and `sort_direction` headers.","ref":"reusing-swagger-parameters.html#scenario"},{"type":"extras","title":"Extracting parameters into a module for reuse - Reusing swagger parameters","doc":"The `swagger_path` macro layer is actually just some syntactic sugar over regular elixir functions, intended to be easily extended. Any function that accepts a `%PhoenixSwagger.Path.PathObject{}` as its first argument and returns an updated `%PathObject{}` can be used in the `swagger_path` macro.\n\nKnowing this, we can easily extract some of the common logic into a module and reuse it in our controllers.\n\n```elixir\ndefmodule CommonParameters do\n  @moduledoc \"Common parameter declarations for phoenix swagger\"\n\n  alias PhoenixSwagger.Path.PathObject\n  import PhoenixSwagger.Path\n\n  def authorization(path = %PathObject{}) do\n    path |> parameter(\"Authorization\", :header, :string, \"OAuth2 access token\", required: true)\n  end\n\n  def sorting(path = %PathObject{}) do\n    path\n    |> parameter(:sort_by, :query, :string, \"The property to sort by\")\n    |> parameter(:sort_direction, :query, :string, \"The sort direction\", enum: [:asc, :desc], default: :asc)\n  end\nend\n```\n\nThis can also be done using the `parameters` macro:\n\n```elixir\ndef sorting(path = %PathObject{}) do\n  parameters path do\n    sort_by :query, :string, \"The property to sort by\"\n    sort_direction :query, :string, \"The sort direction\", enum: [:asc, :desc], default: :asc\n  end\nend\n```","ref":"reusing-swagger-parameters.html#extracting-parameters-into-a-module-for-reuse"},{"type":"extras","title":"Reusing the common parameters - Reusing swagger parameters","doc":"Now, instead of defining these parameters in every controller, we can just reference the `CommonParameters` module:\n\n```elixir\ndefmodule ProjectsController do\n  use PhoenixSwagger\n\n  swagger_path :index do\n    get \"/users\"\n    produces \"application/json\"\n    CommonParameters.authorization\n    CommonParameters.sorting\n    parameters do\n      company_id :string, :query, \"The company id\"\n    end\n  end\nend\n```","ref":"reusing-swagger-parameters.html#reusing-the-common-parameters"},{"type":"extras","title":"Swagger UI","doc":"# Swagger UI\n\nPhoenixSwagger includes a plug with all static assets required to host swagger-ui from your Phoenix application.\n\nUsage:\n\nGenerate a swagger file in your applications `priv/static` dir:\n\n```elixir\nconfig :my_app, :phoenix_swagger,\n  swagger_files: %{\n    \"priv/static/swagger.json\" => [router: MyAppWeb.Router]\n  }\n```\n\n```\nmix phx.swagger.generate\n```\n\nAdd a swagger scope to your router, and forward all requests to SwaggerUI\n\n```elixir\nscope \"/api/swagger\" do\n  forward \"/\", PhoenixSwagger.Plug.SwaggerUI, otp_app: :myapp, swagger_file: \"swagger.json\"\nend\n```\n\nRun the server with `mix phx.server` and browse to `localhost:4000/api/swagger`,\nSwagger-ui should be shown with your swagger spec loaded.\n\nSee the [examples/simple](https://github.com/xerions/phoenix_swagger/tree/master/examples/simple) project for a runnable example with swagger-ui.","ref":"swagger-ui.html"},{"type":"extras","title":"Schema Validation","doc":"# Schema Validation\n\nBesides generator of `swagger` schemas, the `phoenix_swagger` provides validator of input parameters of resources.\n\nSuppose you have following resource in your schema:\n\n```\n...\n...\n\"/history\": {\n    \"get\": {\n        \"parameters\": [\n        {\n            \"name\": \"offset\",\n            \"in\": \"query\",\n            \"type\": \"integer\",\n            \"format\": \"int32\",\n            \"description\": \"Offset the list of returned results by this amount. Default is zero.\"\n        },\n        {\n            \"name\": \"limit\",\n            \"in\": \"query\",\n            \"type\": \"integer\",\n            \"format\": \"int32\",\n            \"description\": \"Integer of items to retrieve. Default is 5, maximum is 100.\"\n        }]\n     }\n}\n...\n...\n```\n\nThe `phoenix_swagger` provides `PhoenixSwagger.Validator.parse_swagger_schema/1` API to load a swagger schema by\nthe given path or list of paths. This API should be called during application startup to parse/load a swagger schema.\n\nAfter this, use one of the following to validate resources:\n* the function `PhoenixSwagger.Validator.validate/2` using request path and parameters\n* the default Plug `PhoenixSwagger.Plug.Validate`\n* the function `PhoenixSwagger.ConnValidate.validate/1` using `conn`\n\n### `Validator.validate/2`\n\nFor example:\n\n```elixir\niex(1)> Validator.validate(\"/history\", %{\"limit\" => \"10\"})\n{:error,\"Type mismatch. Expected Integer but got String.\", \"#/limit\"}\n\niex(2)> Validator.validate(\"/history\", %{\"limit\" => 10, \"offset\" => 100})\n:ok\n```","ref":"schema-validation.html"},{"type":"extras","title":"Default Plug - Schema Validation","doc":"To validate input parameters of your controllers with the default Plug, just add `PhoenixSwagger.Plug.Validate` to your router:\n\n```elixir\npipeline :api do\n  plug :accepts, [\"json\"]\n  plug PhoenixSwagger.Plug.Validate\nend\n\nscope \"/api\", MyApp do\n  pipe_through :api\n  post \"/users\", UsersController, :send\nend\n```\n\nOn validation errors, the default Plug returns `400` with the following body:\n```json\n{\n  \"error\": {\n    \"path\": \"#/path/to/schema\",\n    \"message\": \"Expected integer, got null\"\n  }\n}\n```\n\nThe return code for validation errors is configurable via `:validation_failed_status` parameter.\nIf `conn.private[:phoenix_swagger][:valid]` is set to `true`, the Plug will skip validation.\n\n### `ConnValidator.validate/1`\n\nUse `ConnValidator.validate/1` to build your own Plugs. It accepts a `conn` and returns `:ok` on validation success. Refer to source for error cases.","ref":"schema-validation.html#default-plug"},{"type":"extras","title":"Test Helpers","doc":"# Test Helpers\n\nPhoenixSwagger also includes a testing helper module `PhoenixSwagger.SchemaTest` to conveniently assert that responses\nfrom Phoenix controller actions conform to your swagger schema.\n\nIn order to validate the swagger schema, the properties options must be required true in swagger definitions:\n\n```elixir\n  properties do\n    id(:integer, \"User ID\")\n    name(:string, \"User name\", required: true)\n    email(:string, \"Email address\", format: :email, required: true)\n    inserted_at(:string, \"Creation timestamp\", format: :datetime)\n    updated_at(:string, \"Update timestamp\", format: :datetime)\n  end\n```\n\n\nIn your controller test files add the `PhoenixSwagger.SchemaTest` mixin with the path to your swagger spec:\n\n```elixir\ndefmodule YourApp.UserControllerTest do\n  use YourApp.ConnCase, async: true\n  use PhoenixSwagger.SchemaTest, \"priv/static/swagger.json\"\n```\n\nThen in each test, the context will contain the swagger_schema, which can be used with\nthe `validate_resp_schema` function:\n\n```elixir\ntest \"shows chosen resource\", %{conn: conn, swagger_schema: schema} do\n  user = Repo.insert! struct(User, @valid_attrs)\n  response =\n    conn\n    |> get(user_path(conn, :show, user))\n    |> validate_resp_schema(schema, \"UserResponse\")\n    |> json_response(200)\nend\n```","ref":"test-helpers.html"},{"type":"extras","title":"Live Reloading","doc":"# Live Reloading\n\nLive reloading can be use to automatically regenerate the swagger files and reload the swagger-ui when controller files change.\nTo enable live reloading:\n\n - Ensure `phoenix_swagger` is added as a compiler in your `mix.exs` file\n - Add the path to the swagger JSON files and controllers to the endpoint `live_reload` config\n - Add the `reloadable_compilers` configuration to the endpoint config, including the `:phoenix_swagger` compiler\n\n```elixir\nconfig :your_app, YourApp.Endpoint,\n  live_reload: [\n    patterns: [\n      ~r{priv/static/.*(js|css|png|jpeg|jpg|gif|svg|json)$},\n      ~r{priv/gettext/.*(po)$},\n      ~r{lib/your_app_web/views/.*(ex)$},\n      ~r{lib/your_app_web/controllers/.*(ex)$},\n      ~r{lib/your_app_web/templates/.*(eex)$}\n    ]\n  ],\n  reloadable_compilers: [:gettext, :phoenix, :elixir, :phoenix_swagger]\n```","ref":"live-reloading.html"},{"type":"extras","title":"JSON:API Helpers","doc":"# JSON:API Helpers\n\nThe `PhoenixSwagger.JsonApi` module provides helpers for constructing JSON:API schemas easily.\n`PhoenixSwagger.JsonApi.resource/1` describes a JSON:API [resource object](http://jsonapi.org/format/#document-resource-objects).\n`PhoenixSwagger.JsonApi.page/1` and `PhoenixSwagger.JsonApi.single/1` can then be used to wrap a resource in a JSON:API [top level object](http://jsonapi.org/format/#document-top-level)\n\nExample:\n\n```elixir\nuse PhoenixSwagger\n\ndef swagger_definitions do\n  %{\n    UserResource: JsonApi.resource do\n      description \"A user that may have one or more supporter pages.\"\n      attributes do\n        phone :string, \"Users phone number\"\n        full_name :string, \"Full name\"\n        user_updated_at :string, \"Last update timestamp UTC\", format: \"ISO-8601\"\n        user_created_at :string, \"First created timestamp UTC\"\n        email :string, \"Email\", required: true\n        birthday :string, \"Birthday in YYYY-MM-DD format\"\n        address Schema.ref(:Address), \"Users address\"\n      end\n      link :self, \"The link to this user resource\"\n      relationship :preferences\n      relationship :posts, type: :has_many\n    end,\n    Users: JsonApi.page(:UserResource),\n    User: JsonApi.single(:UserResource)\n  }\nend\n\nswagger_path :index do\n  get \"/api/v1/users\"\n  paging size: \"page[size]\", number: \"page[number]\"\n  response 200, \"OK\", Schema.ref(:Users)\nend\n```","ref":"json-api-helpers.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.1"}}